# Generated by Django 4.2.6 on 2025-01-14 13:55

import digid_eherkenning.choices
import digid_eherkenning.models.digid
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import privates.fields
import privates.storages
import uuid


class Migration(migrations.Migration):

    replaces = [
        ("digid_eherkenning", "0001_initial"),
        ("digid_eherkenning", "0002_auto_20221102_1046"),
        ("digid_eherkenning", "0003_digidconfiguration_artifact_resolve_content_type"),
        ("digid_eherkenning", "0004_alter_eherkenningconfiguration_loa"),
        (
            "digid_eherkenning",
            "0005_alter_eherkenningconfiguration_eh_service_instance_uuid_and_more",
        ),
        ("digid_eherkenning", "0006_digidconfiguration_metadata_file_source_and_more"),
        ("digid_eherkenning", "0007_eherkenningconfiguration_service_description_url"),
        ("digid_eherkenning", "0008_update_loa_fields"),
        ("digid_eherkenning", "0009_decrypt_private_keys"),
        ("digid_eherkenning", "0010_remove_digidconfiguration_key_passphrase_and_more"),
        (
            "digid_eherkenning",
            "0011_configcertificate_configcertificate_uniq_config_cert",
        ),
        ("digid_eherkenning", "0012_move_config_certificate"),
        (
            "digid_eherkenning",
            "0013_alter_eherkenningconfiguration_eh_requested_attributes_and_more",
        ),
        (
            "digid_eherkenning",
            "0014_alter_eherkenningconfiguration_digest_algorithm_and_more",
        ),
        (
            "digid_eherkenning",
            "0015_digidconfiguration_administrative_contact_person_email_and_more",
        ),
        (
            "digid_eherkenning",
            "0016_eherkenningconfiguration_eidas_service_description",
        ),
    ]

    dependencies = [
        ("simple_certmanager", "0001_initial"),
        ("simple_certmanager", "0002_alter_certificate_private_key_and_more"),
    ]

    operations = [
        migrations.CreateModel(
            name="DigidConfiguration",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "idp_metadata_file",
                    privates.fields.PrivateMediaFileField(
                        blank=True,
                        help_text="The metadata file of the identity provider. This is auto populated from the configured source URL.",
                        storage=privates.storages.PrivateMediaFileSystemStorage(),
                        upload_to="",
                        verbose_name="identity provider metadata",
                    ),
                ),
                (
                    "idp_service_entity_id",
                    models.CharField(
                        blank=True,
                        help_text="Example value: 'https://was-preprod1.digid.nl/saml/idp/metadata'. Note that this must match the 'entityID' attribute on the 'md:EntityDescriptor' node found in the Identity Provider's metadata. This is auto populated from the configured source URL.",
                        max_length=255,
                        verbose_name="identity provider service entity ID",
                    ),
                ),
                (
                    "want_assertions_signed",
                    models.BooleanField(
                        default=True,
                        help_text="If True, the XML assertions need to be signed, otherwise the whole response needs to be signed.",
                        max_length=100,
                        verbose_name="want assertions signed",
                    ),
                ),
                (
                    "want_assertions_encrypted",
                    models.BooleanField(
                        default=False,
                        help_text="If True the XML assertions need to be encrypted.",
                        max_length=100,
                        verbose_name="want assertions encrypted",
                    ),
                ),
                (
                    "signature_algorithm",
                    models.CharField(
                        blank=True,
                        choices=[
                            ("http://www.w3.org/2000/09/xmldsig#dsa-sha1", "DSA_SHA1"),
                            ("http://www.w3.org/2000/09/xmldsig#rsa-sha1", "RSA_SHA1"),
                            (
                                "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256",
                                "RSA_SHA256",
                            ),
                            (
                                "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384",
                                "RSA_SHA384",
                            ),
                            (
                                "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512",
                                "RSA_SHA512",
                            ),
                        ],
                        default="http://www.w3.org/2000/09/xmldsig#rsa-sha1",
                        help_text="Signature algorithm. Note that DSA_SHA1 and RSA_SHA1 are deprecated, but RSA_SHA1 is still the default value in the SAMLv2 standard. Warning: there are known issues with single-logout functionality if using anything other than SHA1 due to some hardcoded algorithm.",
                        max_length=100,
                        verbose_name="signature algorithm",
                    ),
                ),
                (
                    "digest_algorithm",
                    models.CharField(
                        blank=True,
                        choices=[
                            ("http://www.w3.org/2000/09/xmldsig#sha1", "SHA1"),
                            ("http://www.w3.org/2001/04/xmlenc#sha256", "SHA256"),
                            ("http://www.w3.org/2001/04/xmldsig-more#sha384", "SHA384"),
                            ("http://www.w3.org/2001/04/xmlenc#sha512", "SHA512"),
                        ],
                        default="http://www.w3.org/2000/09/xmldsig#sha1",
                        help_text="Digest algorithm. Note that SHA1 is deprecated, but still the default value in the SAMLv2 standard. Warning: there are known issues with single-logout functionality if using anything other than SHA1 due to some hardcoded algorithm.",
                        max_length=100,
                        verbose_name="digest algorithm",
                    ),
                ),
                (
                    "entity_id",
                    models.CharField(
                        help_text="Service provider entity ID.",
                        max_length=100,
                        verbose_name="entity ID",
                    ),
                ),
                (
                    "base_url",
                    models.URLField(
                        help_text="Base URL of the application, without trailing slash.",
                        max_length=100,
                        verbose_name="base URL",
                    ),
                ),
                (
                    "service_name",
                    models.CharField(
                        help_text="Name of the service you are providing.",
                        max_length=100,
                        verbose_name="service name",
                    ),
                ),
                (
                    "service_description",
                    models.CharField(
                        help_text="A description of the service you are providing.",
                        max_length=100,
                        verbose_name="service description",
                    ),
                ),
                (
                    "technical_contact_person_telephone",
                    models.CharField(
                        blank=True,
                        help_text="Telephone number of the technical person responsible for this DigiD/eHerkenning/eIDAS setup. For it to show up in the metadata, you should also specify the email address.",
                        max_length=100,
                        verbose_name="technical contact: phone number",
                    ),
                ),
                (
                    "technical_contact_person_email",
                    models.CharField(
                        blank=True,
                        help_text="Email address of the technical person responsible for this DigiD/eHerkenning/eIDAS setup. For it to show up in the metadata, you should also specify the phone number.",
                        max_length=100,
                        verbose_name="technical contact: email",
                    ),
                ),
                (
                    "organization_url",
                    models.URLField(
                        blank=True,
                        help_text="URL of the organization providing the service for which DigiD/eHerkenning/eIDAS login is configured. For it to show up in the metadata, you should also specify the organization name.",
                        max_length=255,
                        verbose_name="organization URL",
                    ),
                ),
                (
                    "organization_name",
                    models.CharField(
                        blank=True,
                        help_text="URL of the organization providing the service for which DigiD/eHerkenning/eIDAS login is configured. For it to show up in the metadata, you should also specify the organization URL.",
                        max_length=100,
                        verbose_name="organization name",
                    ),
                ),
                (
                    "attribute_consuming_service_index",
                    models.CharField(
                        blank=True,
                        default="1",
                        help_text="Attribute consuming service index",
                        max_length=100,
                        verbose_name="Attribute consuming service index",
                    ),
                ),
                (
                    "requested_attributes",
                    models.JSONField(
                        default=digid_eherkenning.models.digid.default_digid_requested_attributes,
                        help_text="A list of strings (or objects) with the requested attributes, e.g. '[\"bsn\"]'",
                        verbose_name="requested attributes",
                    ),
                ),
                (
                    "slo",
                    models.BooleanField(
                        default=True,
                        help_text="If enabled, Single Logout is supported",
                        verbose_name="Single logout",
                    ),
                ),
                (
                    "administrative_contact_person_email",
                    models.CharField(
                        blank=True,
                        help_text="Email address of the administrative contact person responsible for this DigiD/eHerkenning/eIDAS setup. For it to show up in the metadata, you should also specify the phone number.",
                        max_length=100,
                        verbose_name="administrative contact: email",
                    ),
                ),
                (
                    "administrative_contact_person_telephone",
                    models.CharField(
                        blank=True,
                        help_text="Telephone number of the administrative contact person responsible for this DigiD/eHerkenning/eIDAS setup. For it to show up in the metadata, you should also specify the email address.",
                        max_length=100,
                        verbose_name="administrative contact: phone number",
                    ),
                ),
                (
                    "artifact_resolve_content_type",
                    models.CharField(
                        choices=[
                            ("application/soap+xml", "application/soap+xml"),
                            ("text/xml", "text/xml"),
                        ],
                        default="application/soap+xml",
                        help_text="'application/soap+xml' is considered legacy and modern brokers typically expect 'text/xml'.",
                        max_length=100,
                        verbose_name="resolve artifact binding content type",
                    ),
                ),
                (
                    "metadata_file_source",
                    models.URLField(
                        default="",
                        help_text="The URL-source where the XML metadata file can be retrieved from.",
                        max_length=255,
                        verbose_name="metadata file(XML) URL",
                    ),
                ),
            ],
            options={
                "verbose_name": "Digid configuration",
            },
        ),
        migrations.CreateModel(
            name="EherkenningConfiguration",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "idp_metadata_file",
                    privates.fields.PrivateMediaFileField(
                        blank=True,
                        help_text="The metadata file of the identity provider. This is auto populated from the configured source URL.",
                        storage=privates.storages.PrivateMediaFileSystemStorage(),
                        upload_to="",
                        verbose_name="identity provider metadata",
                    ),
                ),
                (
                    "idp_service_entity_id",
                    models.CharField(
                        blank=True,
                        help_text="Example value: 'https://was-preprod1.digid.nl/saml/idp/metadata'. Note that this must match the 'entityID' attribute on the 'md:EntityDescriptor' node found in the Identity Provider's metadata. This is auto populated from the configured source URL.",
                        max_length=255,
                        verbose_name="identity provider service entity ID",
                    ),
                ),
                (
                    "want_assertions_signed",
                    models.BooleanField(
                        default=True,
                        help_text="If True, the XML assertions need to be signed, otherwise the whole response needs to be signed.",
                        max_length=100,
                        verbose_name="want assertions signed",
                    ),
                ),
                (
                    "want_assertions_encrypted",
                    models.BooleanField(
                        default=False,
                        help_text="If True the XML assertions need to be encrypted.",
                        max_length=100,
                        verbose_name="want assertions encrypted",
                    ),
                ),
                (
                    "signature_algorithm",
                    models.CharField(
                        blank=True,
                        choices=[
                            (
                                "http://www.w3.org/2001/04/xmldsig-more#rsa-sha256",
                                "RSA_SHA256",
                            ),
                            (
                                "http://www.w3.org/2001/04/xmldsig-more#rsa-sha384",
                                "RSA_SHA384",
                            ),
                            (
                                "http://www.w3.org/2001/04/xmldsig-more#rsa-sha512",
                                "RSA_SHA512",
                            ),
                        ],
                        default="http://www.w3.org/2001/04/xmldsig-more#rsa-sha256",
                        help_text="Signature algorithm. Note that DSA_SHA1 and RSA_SHA1 are deprecated, but RSA_SHA1 is still the default value in the SAMLv2 standard. Warning: there are known issues with single-logout functionality if using anything other than SHA1 due to some hardcoded algorithm.",
                        max_length=100,
                        verbose_name="signature algorithm",
                    ),
                ),
                (
                    "digest_algorithm",
                    models.CharField(
                        blank=True,
                        choices=[
                            ("http://www.w3.org/2001/04/xmlenc#sha256", "SHA256"),
                            ("http://www.w3.org/2001/04/xmldsig-more#sha384", "SHA384"),
                            ("http://www.w3.org/2001/04/xmlenc#sha512", "SHA512"),
                        ],
                        default="http://www.w3.org/2001/04/xmlenc#sha256",
                        help_text="Digest algorithm. Note that SHA1 is deprecated, but still the default value in the SAMLv2 standard. Warning: there are known issues with single-logout functionality if using anything other than SHA1 due to some hardcoded algorithm.",
                        max_length=100,
                        verbose_name="digest algorithm",
                    ),
                ),
                (
                    "entity_id",
                    models.CharField(
                        help_text="Service provider entity ID.",
                        max_length=100,
                        verbose_name="entity ID",
                    ),
                ),
                (
                    "base_url",
                    models.URLField(
                        help_text="Base URL of the application, without trailing slash.",
                        max_length=100,
                        verbose_name="base URL",
                    ),
                ),
                (
                    "service_name",
                    models.CharField(
                        help_text="Name of the service you are providing.",
                        max_length=100,
                        verbose_name="service name",
                    ),
                ),
                (
                    "service_description",
                    models.CharField(
                        help_text="A description of the service you are providing.",
                        max_length=100,
                        verbose_name="service description",
                    ),
                ),
                (
                    "technical_contact_person_telephone",
                    models.CharField(
                        blank=True,
                        help_text="Telephone number of the technical person responsible for this DigiD/eHerkenning/eIDAS setup. For it to show up in the metadata, you should also specify the email address.",
                        max_length=100,
                        verbose_name="technical contact: phone number",
                    ),
                ),
                (
                    "technical_contact_person_email",
                    models.CharField(
                        blank=True,
                        help_text="Email address of the technical person responsible for this DigiD/eHerkenning/eIDAS setup. For it to show up in the metadata, you should also specify the phone number.",
                        max_length=100,
                        verbose_name="technical contact: email",
                    ),
                ),
                (
                    "organization_url",
                    models.URLField(
                        blank=True,
                        help_text="URL of the organization providing the service for which DigiD/eHerkenning/eIDAS login is configured. For it to show up in the metadata, you should also specify the organization name.",
                        max_length=255,
                        verbose_name="organization URL",
                    ),
                ),
                (
                    "organization_name",
                    models.CharField(
                        blank=True,
                        help_text="URL of the organization providing the service for which DigiD/eHerkenning/eIDAS login is configured. For it to show up in the metadata, you should also specify the organization URL.",
                        max_length=100,
                        verbose_name="organization name",
                    ),
                ),
                (
                    "eh_loa",
                    models.CharField(
                        choices=[
                            (
                                "urn:etoegang:core:assurance-class:loa1",
                                "Non existent (1)",
                            ),
                            ("urn:etoegang:core:assurance-class:loa2", "Low (2)"),
                            ("urn:etoegang:core:assurance-class:loa2plus", "Low (2+)"),
                            (
                                "urn:etoegang:core:assurance-class:loa3",
                                "Substantial (3)",
                            ),
                            ("urn:etoegang:core:assurance-class:loa4", "High (4)"),
                        ],
                        default="urn:etoegang:core:assurance-class:loa3",
                        help_text="Level of Assurance (LoA) to use for the eHerkenning service.",
                        max_length=100,
                        verbose_name="eHerkenning LoA",
                    ),
                ),
                (
                    "eh_attribute_consuming_service_index",
                    models.CharField(
                        blank=True,
                        default="9052",
                        help_text="Attribute consuming service index for the eHerkenning service",
                        max_length=100,
                        verbose_name="eHerkenning attribute consuming service index",
                    ),
                ),
                (
                    "eh_requested_attributes",
                    models.JSONField(
                        blank=True,
                        default=list,
                        help_text="A list of additional requested attributes. A single requested attribute can be a string (the name of the attribute) or an object with keys 'name' and 'required', where 'name' is a string and 'required' a boolean'.",
                        verbose_name="requested attributes",
                    ),
                ),
                (
                    "eh_service_uuid",
                    models.UUIDField(
                        default=uuid.uuid4,
                        help_text="UUID of the eHerkenning service. Once entered into catalogues, changing the value is a manual process.",
                        verbose_name="eHerkenning service UUID",
                    ),
                ),
                (
                    "eh_service_instance_uuid",
                    models.UUIDField(
                        default=uuid.uuid4,
                        help_text="UUID of the eHerkenning service instance. Once entered into catalogues, changing the value is a manual process.",
                        verbose_name="eHerkenning service instance UUID",
                    ),
                ),
                (
                    "eidas_attribute_consuming_service_index",
                    models.CharField(
                        blank=True,
                        default="9053",
                        help_text="Attribute consuming service index for the eIDAS service",
                        max_length=100,
                        verbose_name="eIDAS attribute consuming service index",
                    ),
                ),
                (
                    "eidas_requested_attributes",
                    models.JSONField(
                        blank=True,
                        default=list,
                        help_text="A list of additional requested attributes. A single requested attribute can be a string (the name of the attribute) or an object with keys 'name' and 'required', where 'name' is a string and 'required' a boolean'.",
                        verbose_name="requested attributes",
                    ),
                ),
                (
                    "eidas_service_uuid",
                    models.UUIDField(
                        default=uuid.uuid4,
                        help_text="UUID of the eIDAS service. Once entered into catalogues, changing the value is a manual process.",
                        verbose_name="eIDAS service UUID",
                    ),
                ),
                (
                    "eidas_service_instance_uuid",
                    models.UUIDField(
                        default=uuid.uuid4,
                        help_text="UUID of the eIDAS service instance. Once entered into catalogues, changing the value is a manual process.",
                        verbose_name="eIDAS service instance UUID",
                    ),
                ),
                (
                    "oin",
                    models.CharField(
                        help_text="The OIN of the company providing the service.",
                        max_length=100,
                        validators=[
                            django.core.validators.RegexValidator(
                                message="A valid OIN consists of 20 digits.",
                                regex="[0-9]{20}",
                            )
                        ],
                        verbose_name="OIN",
                    ),
                ),
                (
                    "no_eidas",
                    models.BooleanField(
                        blank=True,
                        default=False,
                        help_text="If True, then the service catalogue will contain only the eHerkenning service.",
                        verbose_name="no eIDAS",
                    ),
                ),
                (
                    "privacy_policy",
                    models.URLField(
                        help_text="The URL where the privacy policy from the organization providing the service can be found.",
                        max_length=255,
                        verbose_name="privacy policy",
                    ),
                ),
                (
                    "makelaar_id",
                    models.CharField(
                        help_text="OIN of the broker used to set up eHerkenning/eIDAS.",
                        max_length=100,
                        validators=[
                            django.core.validators.RegexValidator(
                                message="A valid OIN consists of 20 digits.",
                                regex="[0-9]{20}",
                            )
                        ],
                        verbose_name="broker ID",
                    ),
                ),
                (
                    "artifact_resolve_content_type",
                    models.CharField(
                        choices=[
                            ("application/soap+xml", "application/soap+xml"),
                            ("text/xml", "text/xml"),
                        ],
                        default="application/soap+xml",
                        help_text="'application/soap+xml' is considered legacy and modern brokers typically expect 'text/xml'.",
                        max_length=100,
                        verbose_name="resolve artifact binding content type",
                    ),
                ),
                (
                    "service_language",
                    models.CharField(
                        default="nl",
                        help_text="Metadata for eHerkenning/eidas will contain this language key",
                        max_length=2,
                        verbose_name="service language",
                    ),
                ),
                (
                    "administrative_contact_person_email",
                    models.CharField(
                        blank=True,
                        help_text="Email address of the administrative contact person responsible for this DigiD/eHerkenning/eIDAS setup. For it to show up in the metadata, you should also specify the phone number.",
                        max_length=100,
                        verbose_name="administrative contact: email",
                    ),
                ),
                (
                    "administrative_contact_person_telephone",
                    models.CharField(
                        blank=True,
                        help_text="Telephone number of the administrative contact person responsible for this DigiD/eHerkenning/eIDAS setup. For it to show up in the metadata, you should also specify the email address.",
                        max_length=100,
                        verbose_name="administrative contact: phone number",
                    ),
                ),
                (
                    "eidas_service_description",
                    models.CharField(
                        blank=True,
                        help_text="A description of the service you are providing. If left blank, the eHerkenning description is re-used.",
                        max_length=100,
                        verbose_name="service description (eIDAS)",
                    ),
                ),
                (
                    "metadata_file_source",
                    models.URLField(
                        default="",
                        help_text="The URL-source where the XML metadata file can be retrieved from.",
                        max_length=255,
                        verbose_name="metadata file(XML) URL",
                    ),
                ),
                (
                    "service_description_url",
                    models.URLField(
                        default="",
                        help_text="The URL where the service description can be found.",
                        max_length=255,
                        verbose_name="service description URL",
                    ),
                ),
                (
                    "eidas_loa",
                    models.CharField(
                        choices=[
                            (
                                "urn:etoegang:core:assurance-class:loa1",
                                "Non existent (1)",
                            ),
                            ("urn:etoegang:core:assurance-class:loa2", "Low (2)"),
                            ("urn:etoegang:core:assurance-class:loa2plus", "Low (2+)"),
                            (
                                "urn:etoegang:core:assurance-class:loa3",
                                "Substantial (3)",
                            ),
                            ("urn:etoegang:core:assurance-class:loa4", "High (4)"),
                        ],
                        default="urn:etoegang:core:assurance-class:loa3",
                        help_text="Level of Assurance (LoA) to use for the eIDAS service.",
                        max_length=100,
                        verbose_name="eIDAS LoA",
                    ),
                ),
            ],
            options={
                "verbose_name": "Eherkenning/eIDAS configuration",
            },
        ),
        migrations.AddConstraint(
            model_name="eherkenningconfiguration",
            constraint=models.CheckConstraint(
                check=models.Q(
                    models.Q(
                        ("eh_loa__in", digid_eherkenning.choices.AssuranceLevels),
                        ("eidas_loa__in", digid_eherkenning.choices.AssuranceLevels),
                    )
                ),
                name="valid_loa",
            ),
        ),
        migrations.CreateModel(
            name="ConfigCertificate",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "config_type",
                    models.CharField(
                        choices=[
                            ("digid_eherkenning.DigidConfiguration", "DigiD"),
                            (
                                "digid_eherkenning.EherkenningConfiguration",
                                "eHerkenning",
                            ),
                        ],
                        max_length=100,
                        verbose_name="config type",
                    ),
                ),
                (
                    "certificate",
                    models.ForeignKey(
                        help_text="Certificate that may be used by the specified configuration. The best matching candidate will automatically be selected by the configuration.",
                        limit_choices_to={"type": "key_pair"},
                        on_delete=django.db.models.deletion.PROTECT,
                        to="simple_certmanager.certificate",
                        verbose_name="certificate",
                    ),
                ),
            ],
            options={
                "verbose_name": "DigiD/eHerkenning certificate",
                "verbose_name_plural": "DigiD/eHerkenning certificates",
            },
        ),
        migrations.AddConstraint(
            model_name="configcertificate",
            constraint=models.UniqueConstraint(
                fields=("config_type", "certificate"),
                name="uniq_config_cert",
                violation_error_message="This configuration and certificate combination already exists.",
            ),
        ),
    ]
